#include <stdlib.h>
#include <string.h>

#include "Common.h"
#include "InterTables.h"
#include "ix86/ix86.h"
#include "iR5900.h"

#include <math.h>
#include <stdlib.h>
#include <string.h>
#include "Common.h"
#include "Debug.h"
#include "R5900.h"
#include "InterTables.h"
#include "VU0.h"
#include "VUmicro.h"
#include "VU0.h"
#include "iVU0micro.h"
#include "iVUmicro.h"


#ifdef __WIN32__
#pragma warning(disable:4244)
#pragma warning(disable:4761)
#endif

extern u32 pc;			/* recompiler pc */

#define _Ft_ _Rt_
#define _Fs_ _Rd_
#define _Fd_ _Sa_

#define _Fsf_ ((cpuRegs.code >> 21) & 0x03)
#define _Ftf_ ((cpuRegs.code >> 23) & 0x03)
#define _Cc_ (cpuRegs.code & 0x03)



#define REC_COP2_FUNC(f) \
	void f(); \
	void rec##f() { \
	/*CPU_LOG("Uncompiled COP2:%s\n", disR5900F(cpuRegs.code, cpuRegs.pc));*/\
	MOV32ItoM((u32)&cpuRegs.code, cpuRegs.code); \
	MOV32ItoM((u32)&cpuRegs.pc, pc); \
	iFlushCall(); \
	CALLFunc((u32)f); \
}

#define INTERPRETATE_COP2_FUNC(f) { \
	/*CPU_LOG("Uncompiled COP2:%s\n", disR5900F(cpuRegs.code, cpuRegs.pc));*/\
	MOV32ItoM((u32)&cpuRegs.code, cpuRegs.code); \
	MOV32ItoM((u32)&cpuRegs.pc, pc); \
	iFlushCall(); \
	CALLFunc((u32)f); \
}

#define VCOP2_FUNC(name) \
void recV##name() { VU0.code = cpuRegs.code; recVU0MI_##name(); }

void rec_C2UNK()
{
	SysPrintf("Cop2 bad opcode:%x",cpuRegs.code);
}

void (*recCOP2t[32])();
void (*recCOP2_BC2t[32])();
void (*recCOP2SPECIAL1t[64])();
void (*recCOP2SPECIAL2t[128])();

void recCOP2();
void recCOP2_SPECIAL();
void recCOP2_BC2();
void recCOP2_SPECIAL2();



//////////////////////////////////////////////////////////////////////////
//COP2 
//////////////////////////////////////////////////////////////////////////

REC_COP2_FUNC(QMFC2);
REC_COP2_FUNC(QMTC2);
REC_COP2_FUNC(CFC2);
REC_COP2_FUNC(CTC2);

/*
//TODO:
//Sign extend
//Intercklock for micro mode
//  [1/20/2003]
void recCFC2()
{
	MOV32MtoR(EAX,(u32)&VU0.VI[_Fs_].UL);
	MOV32RtoM((u32)&cpuRegs.GPR.r[_Rt_].UL[0],EAX);
}

//TODO:
//Intercklock for micro mode
//  [1/20/2003]
void recCTC2()
{
	// Need to fix this
	if(_Fs_ != 31){
		MOV32MtoR(EAX,(u32)&cpuRegs.GPR.r[_Rt_].UL);
		MOV32RtoM((u32)&VU0.VI[_Fs_].UL,EAX);
	}else 
	{
		MOV32MtoR(EAX,(u32)&cpuRegs.GPR.r[_Rt_].UL);
		MOV32RtoM((u32)&VU0.VI[REG_CMSAR1].UL,EAX);
		while ((VU1.VI[REG_VPU_STAT].UL & 0x1) == 0) {
			vu1ExecMicro(VU1.VI[REG_TPC].UL);
		}
        MOV32RtoM((u32)&VU1.VI[REG_TPC].UL,EAX);
		
		vu1ExecMicro(VU1.VI[REG_TPC].UL);	// Execute VU1 Micro SubRoutine
	}
}

//TODO:
//Intercklock for micro mode
//  [1/20/2003]
void recQMFC2(void)
{
	CPU_SSE_START;
	MOVAPSMtoR(XMM0,(u32)&VU0.VF[_Fs_].UD[0]);
	MOVAPSRtoM((u32)&cpuRegs.GPR.r[_Rt_].UD[0],XMM0);
    CPU_SSE_END;

	MOVQMtoR(MM0,(u32)&VU0.VF[_Fs_].UD[0]);
	MOVQMtoR(MM1,(u32)&VU0.VF[_Fs_].UD[1]);
	MOVQRtoM((u32)&cpuRegs.GPR.r[_Rt_].UD[0],MM0);
	MOVQRtoM((u32)&cpuRegs.GPR.r[_Rt_].UD[1],MM1);
	SetMMXstate();
}

//TODO:
//Intercklock for micro mode
//  [1/20/2003]
void recQMTC2()
{
	CPU_SSE_START;
	MOVAPSMtoR(XMM0,(u32)&cpuRegs.GPR.r[_Rt_].UD[0]);
	MOVAPSRtoM((u32)&VU0.VF[_Fs_].UD[0],XMM0);
	CPU_SSE_END;

	MOVQMtoR(MM0,(u32)&cpuRegs.GPR.r[_Rt_].UD[0]);
	MOVQMtoR(MM1,(u32)&cpuRegs.GPR.r[_Rt_].UD[1]);
	MOVQRtoM((u32)&VU0.VF[_Fs_].UD[0],MM0);
	MOVQRtoM((u32)&VU0.VF[_Fs_].UD[1],MM1);
	SetMMXstate();
}
*/

//////////////////////////////////////////////////////////////////////////
//    BC2: Instructions 
//////////////////////////////////////////////////////////////////////////
REC_COP2_FUNC(BC2F);
REC_COP2_FUNC(BC2T);
REC_COP2_FUNC(BC2FL);
REC_COP2_FUNC(BC2TL);

//////////////////////////////////////////////////////////////////////////
//    Special1 instructions 
//////////////////////////////////////////////////////////////////////////
//TODO: redirect all the opcodes to the ivu0micro same functions
void recVIADD()   
{
	if(!Config.VUrec) { VU0.code = cpuRegs.code; recVU0MI_IADD(); }//ivu0micro
	else { INTERPRETATE_COP2_FUNC(VIADD); }
} 
void recVIADDI()  
{ 
	if(!Config.VUrec) { VU0.code = cpuRegs.code; recVU0MI_IADDI();} //ivu0micro
	else { INTERPRETATE_COP2_FUNC(VIADDI); }
}
void recVISUB()   
{ 
	if(!Config.VUrec) { VU0.code = cpuRegs.code; recVU0MI_ISUB();}//ivu0micro
    else { INTERPRETATE_COP2_FUNC(VISUB); }

}
void recVIAND()   
{ 
	if(!Config.VUrec) { VU0.code = cpuRegs.code; recVU0MI_IAND();}//ivu0micro
    else { INTERPRETATE_COP2_FUNC(VIAND); }
}
void recVIOR()    { INTERPRETATE_COP2_FUNC(VIOR);}
void recVOPMSUB() {	INTERPRETATE_COP2_FUNC(VOPMSUB);}
void recVMADDq()  { INTERPRETATE_COP2_FUNC(VMADDq);}
void recVMADDi()  { INTERPRETATE_COP2_FUNC(VMADDi);}
void recVMSUBq()  { INTERPRETATE_COP2_FUNC(VMSUBq);}
void recVMSUBi(){ INTERPRETATE_COP2_FUNC(VMSUBi); }
void recVADDi(){ INTERPRETATE_COP2_FUNC(VADDi);}
void recVADDq(){ INTERPRETATE_COP2_FUNC(VADDq);}
void recVSUBi(){ INTERPRETATE_COP2_FUNC(VSUBi);}
void recVSUBq(){ INTERPRETATE_COP2_FUNC(VSUBq);} 
void recVMULi(){ INTERPRETATE_COP2_FUNC(VMULi);}
void recVMULq(){ INTERPRETATE_COP2_FUNC(VMULq); }
void recVMAXi(){ INTERPRETATE_COP2_FUNC(VMAXi); }
void recVMINIi(){ INTERPRETATE_COP2_FUNC(VMINIi);}
void recVMUL(){ INTERPRETATE_COP2_FUNC(VMUL);}
void recVMAX(){INTERPRETATE_COP2_FUNC(VMAX);}
void recVMADD(){INTERPRETATE_COP2_FUNC(VMADD);}
void recVMSUB(){INTERPRETATE_COP2_FUNC(VMSUB);}
void recVMINIx(){ INTERPRETATE_COP2_FUNC(VMINIx);}
void recVMINIy(){ INTERPRETATE_COP2_FUNC(VMINIy);}
void recVMINIz(){ INTERPRETATE_COP2_FUNC(VMINIz);}
void recVMINIw(){ INTERPRETATE_COP2_FUNC(VMINIw);}
void recVMAXx(){INTERPRETATE_COP2_FUNC(VMAXx);}
void recVMAXy(){INTERPRETATE_COP2_FUNC(VMAXy);}
void recVMAXz(){INTERPRETATE_COP2_FUNC(VMAXz);}
void recVMAXw(){INTERPRETATE_COP2_FUNC(VMAXw);}
void recVMULx(){INTERPRETATE_COP2_FUNC(VMULx);}
void recVMULy(){INTERPRETATE_COP2_FUNC(VMULy);}
void recVMULz(){INTERPRETATE_COP2_FUNC(VMULz);}
void recVMULw(){INTERPRETATE_COP2_FUNC(VMULw);}
void recVADDx(){INTERPRETATE_COP2_FUNC(VADDx);}
void recVADDy(){INTERPRETATE_COP2_FUNC(VADDy);}
void recVADDz(){INTERPRETATE_COP2_FUNC(VADDz);}
void recVADDw(){INTERPRETATE_COP2_FUNC(VADDw);}
void recVSUBx(){INTERPRETATE_COP2_FUNC(VSUBx);}
void recVSUBy(){INTERPRETATE_COP2_FUNC(VSUBy);}
void recVSUBz(){INTERPRETATE_COP2_FUNC(VSUBz);}
void recVSUBw(){INTERPRETATE_COP2_FUNC(VSUBw);}
void recVMADDx(){INTERPRETATE_COP2_FUNC(VMADDx);}
void recVMADDy(){INTERPRETATE_COP2_FUNC(VMADDy);}
void recVMADDz(){INTERPRETATE_COP2_FUNC(VMADDz);}
void recVMADDw(){INTERPRETATE_COP2_FUNC(VMADDw);}
void recVMSUBx(){INTERPRETATE_COP2_FUNC(VMSUBx);}
void recVMSUBy(){INTERPRETATE_COP2_FUNC(VMSUBy);}
void recVMSUBz(){INTERPRETATE_COP2_FUNC(VMSUBz);}
void recVMSUBw(){INTERPRETATE_COP2_FUNC(VMSUBw);}
void recVADD(){INTERPRETATE_COP2_FUNC(VADD);}
void recVSUB(){INTERPRETATE_COP2_FUNC(VSUB);}
void recVMINI(){INTERPRETATE_COP2_FUNC(VMINI);}
//////////////////////////////////////////////////////////////////////////
//  Special2 instructions 
//////////////////////////////////////////////////////////////////////////

void recVCLIPw() { INTERPRETATE_COP2_FUNC(VCLIPw);}
void recVLQI() { INTERPRETATE_COP2_FUNC(VLQI);}
void recVSQI() { INTERPRETATE_COP2_FUNC(VSQI);}
void recVLQD() { INTERPRETATE_COP2_FUNC(VLQD);}
void recVSQD() { INTERPRETATE_COP2_FUNC(VSQD);}
void recVMTIR() { INTERPRETATE_COP2_FUNC(VMTIR);}
void recVMFIR() { INTERPRETATE_COP2_FUNC(VMFIR);}
void recVILWR() { INTERPRETATE_COP2_FUNC(VILWR);}
void recVISWR() { INTERPRETATE_COP2_FUNC(VISWR);}

#ifdef RECOMPILE_VUMI_RANDOM

VCOP2_FUNC(RINIT);
VCOP2_FUNC(RXOR);
VCOP2_FUNC(RNEXT);
VCOP2_FUNC(RGET);

#else

REC_COP2_FUNC(VRINIT);
REC_COP2_FUNC(VRXOR);
REC_COP2_FUNC(VRNEXT);
REC_COP2_FUNC(VRGET);

#endif

void recVITOF0()   { INTERPRETATE_COP2_FUNC(VITOF0);}
void recVITOF4()   { INTERPRETATE_COP2_FUNC(VITOF4);}
void recVITOF12()  { INTERPRETATE_COP2_FUNC(VITOF12);}
void recVITOF15()  { INTERPRETATE_COP2_FUNC(VITOF15);}
void recVFTOI0() { INTERPRETATE_COP2_FUNC(VFTOI0);}
void recVFTOI4() { INTERPRETATE_COP2_FUNC(VFTOI4);}
void recVFTOI12() { INTERPRETATE_COP2_FUNC(VFTOI12);}
void recVFTOI15() { INTERPRETATE_COP2_FUNC(VFTOI15);}
void recVMADDA(){INTERPRETATE_COP2_FUNC(VMADDA);}
void recVMSUBA(){INTERPRETATE_COP2_FUNC(VMSUBA);}
void recVMADDAi(){INTERPRETATE_COP2_FUNC(VMADDAi);}
void recVMADDAq(){INTERPRETATE_COP2_FUNC(VMADDAq);}
void recVMADDAx(){INTERPRETATE_COP2_FUNC(VMADDAx);}
void recVMADDAy(){INTERPRETATE_COP2_FUNC(VMADDAy);}
void recVMADDAz(){INTERPRETATE_COP2_FUNC(VMADDAz);}
void recVMADDAw(){INTERPRETATE_COP2_FUNC(VMADDAw);}
void recVMSUBAi(){INTERPRETATE_COP2_FUNC(VMSUBAi);}
void recVMSUBAq(){INTERPRETATE_COP2_FUNC(VMSUBAq);}
void recVMSUBAx(){INTERPRETATE_COP2_FUNC(VMSUBAx);}
void recVMSUBAy(){INTERPRETATE_COP2_FUNC(VMSUBAy);}
void recVMSUBAz(){INTERPRETATE_COP2_FUNC(VMSUBAz);}
void recVMSUBAw(){INTERPRETATE_COP2_FUNC(VMSUBAw);}
void recVADDAi(){INTERPRETATE_COP2_FUNC(VADDAi);}
void recVADDA(){INTERPRETATE_COP2_FUNC(VADDA);}
void recVSUBA(){INTERPRETATE_COP2_FUNC(VSUBA);}
void recVMULA(){INTERPRETATE_COP2_FUNC(VMULA);}
void recVADDAq(){INTERPRETATE_COP2_FUNC(VADDAq);}
void recVADDAx(){INTERPRETATE_COP2_FUNC(VADDAx);}
void recVADDAy(){INTERPRETATE_COP2_FUNC(VADDAy);}
void recVADDAz(){INTERPRETATE_COP2_FUNC(VADDAz);}
void recVADDAw(){INTERPRETATE_COP2_FUNC(VADDAw);}
void recVSUBAi(){INTERPRETATE_COP2_FUNC(VSUBAi);}
void recVSUBAq(){INTERPRETATE_COP2_FUNC(VSUBAq);}
void recVSUBAx(){INTERPRETATE_COP2_FUNC(VSUBAx);}
void recVSUBAy(){INTERPRETATE_COP2_FUNC(VSUBAy);}
void recVSUBAz(){INTERPRETATE_COP2_FUNC(VSUBAz);}
void recVSUBAw(){INTERPRETATE_COP2_FUNC(VSUBAw);}
void recVMULAi(){INTERPRETATE_COP2_FUNC(VMULAi);}
void recVMULAq(){INTERPRETATE_COP2_FUNC(VMULAq);}
void recVMULAx(){ INTERPRETATE_COP2_FUNC(VMULAx);}
void recVMULAy(){ INTERPRETATE_COP2_FUNC(VMULAy);}
void recVMULAz(){ INTERPRETATE_COP2_FUNC(VMULAz);}
void recVMULAw(){ INTERPRETATE_COP2_FUNC(VMULAw);}
void recVOPMULA(){INTERPRETATE_COP2_FUNC(VOPMULA);}
void recVDIV()  { INTERPRETATE_COP2_FUNC(VDIV);}
void recVMOVE() { INTERPRETATE_COP2_FUNC(VMOVE); }
void recVSQRT() { INTERPRETATE_COP2_FUNC(VSQRT); }
void recVRSQRT(){ INTERPRETATE_COP2_FUNC(VRSQRT);}
void recVMR32(){INTERPRETATE_COP2_FUNC(VMR32);}
void recVABS() {INTERPRETATE_COP2_FUNC(VABS);}
void recVNOP(){}
void recVWAITQ(){}
void recC2VCALLMS() {INTERPRETATE_COP2_FUNC(VCALLMS);	}     
void recC2VCALLMSR() {INTERPRETATE_COP2_FUNC(VCALLMSR);	}  


void (*recCOP2t[32])() = {
    rec_C2UNK,		recQMFC2,       recCFC2,        rec_C2UNK,		rec_C2UNK,		recQMTC2,       recCTC2,        rec_C2UNK,
    recCOP2_BC2,    rec_C2UNK,		rec_C2UNK,		rec_C2UNK,		rec_C2UNK,		rec_C2UNK,		rec_C2UNK,		rec_C2UNK,
    recCOP2_SPECIAL,recCOP2_SPECIAL,recCOP2_SPECIAL,recCOP2_SPECIAL,recCOP2_SPECIAL,recCOP2_SPECIAL,recCOP2_SPECIAL,recCOP2_SPECIAL,
	recCOP2_SPECIAL,recCOP2_SPECIAL,recCOP2_SPECIAL,recCOP2_SPECIAL,recCOP2_SPECIAL,recCOP2_SPECIAL,recCOP2_SPECIAL,recCOP2_SPECIAL,
};

void (*recCOP2_BC2t[32])() = {
    recBC2F,        recBC2T,        recBC2FL,       recBC2TL,       rec_C2UNK,		rec_C2UNK,		rec_C2UNK,		rec_C2UNK,
    rec_C2UNK,		rec_C2UNK,		rec_C2UNK,		rec_C2UNK,		rec_C2UNK,		rec_C2UNK,		rec_C2UNK,		rec_C2UNK,
    rec_C2UNK,		rec_C2UNK,		rec_C2UNK,		rec_C2UNK,		rec_C2UNK,		rec_C2UNK,		rec_C2UNK,		rec_C2UNK,
    rec_C2UNK,		rec_C2UNK,		rec_C2UNK,		rec_C2UNK,		rec_C2UNK,		rec_C2UNK,		rec_C2UNK,		rec_C2UNK,
}; 

void (*recCOP2SPECIAL1t[64])() = { 
 recVADDx,       recVADDy,       recVADDz,       recVADDw,       recVSUBx,        recVSUBy,        recVSUBz,        recVSUBw,  
 recVMADDx,      recVMADDy,      recVMADDz,      recVMADDw,      recVMSUBx,       recVMSUBy,       recVMSUBz,       recVMSUBw, 
 recVMAXx,       recVMAXy,       recVMAXz,       recVMAXw,       recVMINIx,       recVMINIy,       recVMINIz,       recVMINIw, 
 recVMULx,       recVMULy,       recVMULz,       recVMULw,       recVMULq,        recVMAXi,        recVMULi,        recVMINIi,
 recVADDq,       recVMADDq,      recVADDi,       recVMADDi,      recVSUBq,        recVMSUBq,       recVSUBi,        recVMSUBi, 
 recVADD,        recVMADD,       recVMUL,        recVMAX,        recVSUB,         recVMSUB,        recVOPMSUB,      recVMINI,  
 recVIADD,       recVISUB,       recVIADDI,      rec_C2UNK,      recVIAND,        recVIOR,         rec_C2UNK,       rec_C2UNK,
 recC2VCALLMS,   recC2VCALLMSR,    rec_C2UNK,      rec_C2UNK,      recCOP2_SPECIAL2,recCOP2_SPECIAL2,recCOP2_SPECIAL2,recCOP2_SPECIAL2,  
};

void (*recCOP2SPECIAL2t[128])() = {
 recVADDAx      ,recVADDAy      ,recVADDAz      ,recVADDAw      ,recVSUBAx      ,recVSUBAy      ,recVSUBAz      ,recVSUBAw,
 recVMADDAx     ,recVMADDAy     ,recVMADDAz     ,recVMADDAw     ,recVMSUBAx     ,recVMSUBAy     ,recVMSUBAz     ,recVMSUBAw,
 recVITOF0      ,recVITOF4      ,recVITOF12     ,recVITOF15     ,recVFTOI0      ,recVFTOI4      ,recVFTOI12     ,recVFTOI15,
 recVMULAx      ,recVMULAy      ,recVMULAz      ,recVMULAw      ,recVMULAq      ,recVABS        ,recVMULAi      ,recVCLIPw,
 recVADDAq      ,recVMADDAq     ,recVADDAi      ,recVMADDAi     ,recVSUBAq      ,recVMSUBAq     ,recVSUBAi      ,recVMSUBAi,
 recVADDA       ,recVMADDA      ,recVMULA       ,rec_C2UNK      ,recVSUBA       ,recVMSUBA      ,recVOPMULA     ,recVNOP,   
 recVMOVE       ,recVMR32       ,rec_C2UNK      ,rec_C2UNK      ,recVLQI        ,recVSQI        ,recVLQD        ,recVSQD,   
 recVDIV        ,recVSQRT       ,recVRSQRT      ,recVWAITQ      ,recVMTIR       ,recVMFIR       ,recVILWR       ,recVISWR,  
 recVRNEXT      ,recVRGET       ,recVRINIT      ,recVRXOR       ,rec_C2UNK      ,rec_C2UNK      ,rec_C2UNK      ,rec_C2UNK, 
 rec_C2UNK      ,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,
 rec_C2UNK      ,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,
 rec_C2UNK      ,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,
 rec_C2UNK      ,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,
 rec_C2UNK      ,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,
 rec_C2UNK      ,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,
 rec_C2UNK      ,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,rec_C2UNK,
};
int opc;

void recCOP22()
{
	recCOP2t[_Rs_]();
}

void recCOP2_SPECIAL()
{
	recCOP2SPECIAL1t[_Funct_]();
}

void recCOP2_BC2()
{
	recCOP2_BC2t[_Rt_]();
}

void recCOP2_SPECIAL2()
{
	int opc=(cpuRegs.code & 0x3) | ((cpuRegs.code >> 4) & 0x7c);
	recCOP2SPECIAL2t[opc]();
}
